//
//  LSCashDrawer.h
//  cashdrawer
//
//  Created by Joseph Ranieri on 1/21/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <IOKit/hid/IOHIDLib.h>


@interface LSCashDrawer : NSObject {
	IOHIDDeviceRef device;
	uint8_t reportBuffer[20];
	BOOL isOpen;
}

/*! All cash drawers currently connected to the system */
+ (NSArray *)cashDrawers;

/*! Begins searching for cash drawers. When a cash drawer is found or removed,
 *  the cashDrawers array will be updated as needed. */
+ (void)startMatching;

/*! Stops searching for cash drawers. */
+ (void)stopMatching;

/*! Opens the cash drawer. If it is already open, this has no effect. */
- (void)open;

/*! Is this cash drawer still attached to the computer? */
@property(readonly) BOOL isAttached;

/*! Is the cash drawer currently open? */
@property(readonly) BOOL isOpen;

@end
