/*
 *  LSWindowClosingDelegate.h
 *  LightSpeed Cocoa
 *
 *  Created by Yves Meynard on 2011/2/3.
 *  Copyright 2011 Xsilva Systems. All rights reserved.
 *
 */

#import <Cocoa/Cocoa.h>

/*! A protocol for objects that react to a window controller being closed. */
@protocol LSWindowClosingDelegate
- (void) windowWillClose:(NSWindowController*) controller;
@end

/*! A window controller that has a window closing delegate (e.g. to be exposed to RealBasic). */
@protocol LSDelegatingCloseWindowController
- (void) setClosingDelegate:(id<LSWindowClosingDelegate>) delegate;
@end
