//
//  NSAttributedString-XSAExtensions.h
//  LightSpeed Cocoa
//
//  Created by Bertrand Landry-Hétu on 12/23/09.
//  Copyright 2009 Xsilva Systems. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSAttributedString (XSAExtensions)

+(id)attributedString;

+(id)attributedStringWithString:(NSString *) string;

+(id)attributedStringWithString:(NSString *) string attributes: (NSDictionary *)attributes;

/* 
 creates a displayable string for a specific modifier keys/key combo. The attributes dictionary must at least contain an NSFont attribute.
 */
+(id)attributedStringForModifierFlags:(NSUInteger) keyEquivalentModifierMask andKeyEquivalent:(unichar)key attributes:(NSDictionary*)attributes;

-(void)drawWithRect:(NSRect)rect shadowColor:(NSColor *)shadowColor shadowOffset:(NSPoint)shadowOffset;

-(NSRange)XSA_entireRange;

+(id)XSA_lineBreak;

+(id)XSA_space;

+(id)XSA_hyperlinkFromString:(NSString*)inString withURL:(NSURL*)aURL;

@end

@interface NSMutableAttributedString (XSAExtensions)

-(void)appendNewLineIfNeeded;

-(void)appendString: (NSString *)aString;

-(void)appendString: (NSString *)aString 
     withAttributes: (NSDictionary *)attributes;

-(void)XSA_addAttributes:(NSDictionary*)attributes;

-(void)XSA_addAttribute:(NSString *)name value:(id)value;

@end
