/*
 *  NSCellProperties.h
 *  BlackIce
 *
 *  Created by Joseph Ranieri on 8/30/09.
 *  Copyright 2009 Xsilva Systems. All rights reserved.
 *
 */

#import <AppKit/AppKit.h>

@interface NSCell (properties)
@property(retain) NSView *controlView;
@property NSCellType type;
@property NSInteger state;
@property(retain) id target;
@property SEL action;
@property NSInteger tag;
@property(copy) NSString *title;
@property(readonly) BOOL isOpaque;
@property(getter=isEnabled, setter=setEnabled:) BOOL isEnabled;
@property(getter=isContinuous, setter=setContinuous:) BOOL isContinuous;
@property(getter=isEditable, setter=setEditable:) BOOL isEditable;
@property(getter=isSelectable, setter=setSelectable:) BOOL isSelectable;
@property(getter=isBordered, setter=setBordered:) BOOL isBordered;
@property(getter=isBezeled, setter=setBezeled:) BOOL isBezeled;
@property(getter=isScrollable, setter=setScrollable:) BOOL isScrollable;
@property(getter=isHighlighted, setter=setHighlighted:) BOOL isHighlighted;
@property NSTextAlignment alignment;
@property BOOL wraps;
@property(retain) NSFont *font;
@property(readonly) NSString *keyEquivalent;
@property(copy) NSFormatter *formatter;
@property(copy) id<NSCopying> objectValue;
@property(readonly) BOOL hasValidObjectValue;
@property(copy) NSString *stringValue;
@property int intValue;
@property float floatValue;
@property double doubleValue;
@property(copy) NSImage *image;
@property NSControlTint controlTint;
@property NSControlSize controlSize;
@property(retain) id representedObject;
@property(readonly) NSSize cellSize;
@property NSInteger mouseDownFlags;
@property(retain) NSMenu *menu;
@property BOOL sendsActionOnEndEditing;
@property NSWritingDirection baseWritingDirection;
@property NSLineBreakMode lineBreakMode;
@property BOOL allowsUndo;
@property NSInteger integerValue;
@property BOOL truncatesLastVisibleLine;

#ifdef MAC_OS_X_VERSION_10_6
@property NSUserInterfaceLayoutDirection userInterfaceLayoutDirection AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property BOOL usesSingleLineMode AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
#endif

// NSKeyboardUI
@property BOOL refusesFirstResponder;
@property BOOL showsFirstResponder;
@property NSFocusRingType focusRingType;
@property(readonly) BOOL wantsNotificationForMarkedText;

// NSCellAttributedStringMethods
@property(copy) NSAttributedString *attributedStringValue;
@property BOOL allowsEditingTextAttributes;
@property BOOL importsGraphics;

// NSCellMixedState
@property BOOL allowsMixedState;

// NSCellBackgroundStyle
@property NSBackgroundStyle backgroundStyle;
@property(readonly) NSBackgroundStyle interiorBackgroundStyle;
@end
