/*
 *  NSCollectionViewProperties.h
 *  LightSpeed Cocoa
 *
 *  Created by Joseph Ranieri on 10/29/09.
 *  Copyright 2009 Xsilva Systems. All rights reserved.
 *
 */

#import <AppKit/AppKit.h>

@interface NSCollectionViewItem (properties)
@property(readonly) NSCollectionView *collectionView;
@property(retain) id representedObject;
@property(retain) NSView *view;
@property(getter=isSelected, setter=setSelected:) BOOL isSelected;
@end

@interface NSCollectionView (properties)
@property(readonly) BOOL isFirstResponder;
@property(copy) NSArray *content;
@property(getter=isSelectable, setter=setSelectable:) BOOL isSelectable;
@property BOOL allowsMultipleSelection;
@property(copy) NSIndexSet *selectionIndexes;
@property(retain) NSCollectionViewItem *itemPrototype;
@property NSUInteger maxNumberOfRows;
@property NSUInteger maxNumberOfColumns;
@property NSSize minItemSize;
@property NSSize maxItemSize;
@property(copy) NSArray *backgroundColors;
@end
