/*
 *  NSTableViewProperties.h
 *  BlackIce
 *
 *  Created by Joseph Ranieri on 8/29/09.
 *  Copyright 2009 Xsilva Systems. All rights reserved.
 *
 */

#import <AppKit/AppKit.h>

@interface NSTableView (properties)
#ifdef MAC_OS_X_VERSION_10_6
@property(assign) id<NSTableViewDataSource> dataSource;
@property(assign) id<NSTableViewDelegate> delegate;
#else
@property(assign) id dataSource;
@property(assign) id delegate;
#endif

@property(retain) NSTableHeaderView *headerView;
@property(retain) NSView *cornerView;
@property BOOL allowsColumnReordering;
@property BOOL allowsColumnResizing;
@property NSTableViewColumnAutoresizingStyle columnAutoresizingStyle;
@property NSUInteger gridStyleMask;
@property NSSize intercellSpacing;
@property BOOL usesAlternatingRowBackgroundColors;
@property(retain) NSColor *backgroundColor;
@property(retain) NSColor *gridColor;
@property CGFloat rowHeight;
@property(readonly) NSArray *tableColumns;
@property(readonly) NSInteger numberOfColumns;
@property(readonly) NSInteger numberOfRows;
@property(readonly) NSInteger editedColumn;
@property(readonly) NSInteger editedRow;
@property(readonly) NSInteger clickedColumn;
@property(readonly) NSInteger clickedRow;
@property SEL doubleAction;
@property(copy) NSArray *sortDescriptors;
@property(retain) NSTableColumn *highlightedTableColumn;
@property BOOL verticalMotionCanBeginDrag;
@property BOOL allowsMultipleSelection;
@property BOOL allowsEmptySelection;
@property BOOL allowsColumnSelection;
@property(readonly) NSIndexSet *selectedColumnIndexes;
@property(readonly) NSIndexSet *selectedRowIndexes;
@property(readonly) NSInteger selectedColumn;
@property(readonly) NSInteger selectedRow;
@property(readonly) NSInteger numberOfSelectedColumns;
@property(readonly) NSInteger numberOfSelectedRows;
@property BOOL allowsTypeSelect;
@property NSTableViewSelectionHighlightStyle selectionHighlightStyle;
@property(copy) NSString *autosaveName;
@property BOOL autosaveTableColumns;
@property NSInteger focusedColumn;

#ifdef MAC_OS_X_VERSION_10_6
@property NSTableViewDraggingDestinationFeedbackStyle draggingDestinationFeedbackStyle AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
#endif
@end
