/*
 *  NSViewProperties.h
 *  BlackIce
 *
 *  Created by Joseph Ranieri on 8/29/09.
 *  Copyright 2009 Xsilva Systems. All rights reserved.
 *
 */

#import <AppKit/AppKit.h>

@interface NSView (properties)
@property(readonly) NSWindow *window;
@property(readonly) NSView *superview;
@property(copy) NSArray *subviews;
@property(readonly) NSView *opaqueAncestor;
@property(getter=isHidden, setter=setHidden:) BOOL isHidden;
@property BOOL isHiddenOrHasHiddenAncestor;
@property BOOL wantsDefaultClipping;
@property BOOL postsFrameChangedNotifications;
@property BOOL autoresizesSubviews;
@property NSUInteger autoresizingMask;
@property NSRect frame;
@property CGFloat frameRotation;
@property CGFloat frameCenterRotation;
@property CGFloat boundsRotation;
@property NSRect bounds;
@property(readonly) BOOL isFlipped;
@property(readonly) BOOL isRotatedFromBase;
@property(readonly) BOOL isRotatedOrScaledFromBase;
@property(readonly) BOOL isOpaque;
@property(readonly) BOOL canDraw;
@property BOOL needsDisplay;
@property(readonly) NSRect visibleRect;
@property(readonly) NSInteger tag;
@property(readonly) BOOL needsPanelToBecomeKey;
@property(readonly) BOOL mouseDownCanMoveWindow;
@property BOOL wantsLayer;
@property(retain) CALayer *layer;
@property CGFloat alphaValue;
@property(copy) NSArray *backgroundFilters;
@property(retain) CIFilter *compositingFilter;
@property(copy) NSArray *contentFilters;
@property(retain) NSShadow *shadow;
@property(readonly) NSArray *trackingAreas;
@property(readonly) BOOL shouldDrawColor;
@property(readonly) NSScrollView *enclosingScrollView;
@property(copy) NSString *toolTip;
@property(readonly) BOOL inLiveResize;
@property(readonly) BOOL preservesContentDuringLiveResize;
@property(readonly) NSRect rectPreservedDuringLiveResize;

#ifdef MAC_OS_X_VERSION_10_6
@property(readonly) NSTextInputContext *inputContext AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property BOOL canDrawConcurrently AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property BOOL acceptsTouchEvents AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property BOOL wantsRestingTouches AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property NSViewLayerContentsRedrawPolicy layerContentsRedrawPolicy AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
@property NSViewLayerContentsPlacement layerContentsPlacement AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER;
#endif

// NSKeyboardUI
@property(retain) NSView *nextKeyView;
@property(readonly) NSView *previousKeyView;
@property(readonly) NSView *nextValidKeyView;
@property(readonly) NSView *previousValidKeyView;
@property(readonly) BOOL canBecomeKeyView;
@property NSFocusRingType focusRingType;

// NSPrinting
@property(readonly) CGFloat heightAdjustLimit;
@property(readonly) CGFloat widthAdjustLimit;
@property(readonly) NSAttributedString *pageHeader;
@property(readonly) NSAttributedString *pageFooter;
@property(readonly) NSString *printJobTitle;

// NSDrag
@property(readonly) NSArray *registeredDraggedTypes;

// NSFullScreenMode
@property(readonly) BOOL isInFullScreenMode;
@end
