//
//  POSDelegate.h
//  LightSpeed Cocoa
//
//  Created by Joseph Ranieri on 1/10/10.
//  Copyright 2010 Xsilva Systems. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class XSStore;
@class XSGiftCard;
@class XSInvoice;
@class XSCustomer;
@class XSProduct;
/*
 If you update any of the enums, make sure to update them in the bridge as well (POSScreen.mm).
 */

typedef enum {
	POSSearchCustomersDefault,
	POSSearchProductsDefault
} POSDefaultSearchType;

typedef enum {
	POSExistingCustomersDefault,
	POSWalkinCustomersDefault,
} POSDefaultCustomerType;

typedef enum {
	POSMagneticCardSwipe=0,
	POSEncryptedCardSwipe=1,
	POSIPDebitTerminalCardSwipe=2
} POSCardSwipeType;

typedef enum {
	POSNoProcessor = 0,
	POSAuthorizeNetProcessor = 1,
	POSHPSProcessor = 2,
	POSPayPalProcessor = 3,
	POSVeriSignProcessor = 4,
	POSMerchantWareProcessor = 5,
	POSAxiaProcessor = 6,
	POSIntuitMerchantServiceProcessor = 7
} POSProcessorType;

@protocol POSDelegate <NSObject>
- (BOOL)hasPermissionsForAction:(NSString *)action;
- (void)printInvoice:(XSInvoice *)invoice giftReceipt:(BOOL)giftReceipt;
- (void)printGiftCardLabel:(XSGiftCard *)giftcard;
- (void)openTimeSheet;
- (void)openCashDrawerForAFinishedInvoice:(BOOL)finished;
- (BOOL)isCashDrawerOpen;
- (void)openEndOfDayReport;
- (void)openTills;
- (void)setPoleDisplayText:(NSString *)text;
- (void)setPoleDisplayToShowLineItemCode:(NSString *)code price:(NSString*)price andTotal:(NSString*)total;
- (void)setPoleDisplayToShowTotal:(NSString *)total andOwing:(NSString*)owing;
- (void)setPoleDisplayToShowCompany;
- (XSCustomer *)createCustomer;
- (void)editCustomer:(XSCustomer *)customer;
- (void)posDidClose;
- (NSString *)multistoreMatchClause:(XSProduct *)product;
- (NSString *)defaultTaxCode;
- (NSString *)debitTerminalSerialPort;
- (NSString *)ipDebitTerminalHostname;
- (NSString *)ipDebitTerminalPort;
- (POSCardSwipeType)creditCardSwipeType;
- (POSDefaultCustomerType)defaultCustomerType;
- (POSDefaultSearchType)defaultSearchType;
- (POSProcessorType)creditCardProcessor;
- (NSString *)stationName;
- (void)switchedUser;
@end
